from ply import lex

def comma_separated_to_regex(comma_separated: str) -> str:
	items = [item.strip().replace('|', r'\|'), comma_separated.split(',')]
	return '|'.join(items)


t_ATOM = r'[\p{}]+'
t_IDENT = (r'[\p{}_]+')
t_WHITESPACE = r'[\t ]+'

t_RELATION_SYMBOL = comma_separated_to_regex(r'<==>, ==>, =>, <==, >=, <=, =, !=, :=')
t_PREFIX_SYMBOL = comma_separated_to_regex(r'not, cbrt, sqrt')
t_INFIX_SYMBOL = comma_separated_to_regex(r'!')
t_SUFFIX_SYMBOL = comma_separated_to_regex(r'and, or, ^, +, ·, ×')

t_RELATION_OPERATOR = 